
#ifndef __AES_TOOL__
#define __AES_TOOL__

#include "stdafx.h"
#include "WzAes.h"
#include "HmacSha1.h"

#define MAC_SIZE			10
#define MAX_SALT_SIZE		16
#define MAX_PASSWORD_SIZE	32
#define MAX_KEY_SIZE		AES256_KEY_SIZE

#define AES128				1
#define AES192				2
#define AES256				3

#define AES128_KEY_SIZE		16
#define AES192_KEY_SIZE		24
#define AES256_KEY_SIZE		32


#define AES128_SALT_SIZE	8
#define AES192_SALT_SIZE	12
#define AES256_SALT_SIZE	16

#define KEY_PASSWORD_VERIFY_SIZE	2

#define NUMITERATIONS		1000

class CRYPTO_API CAesTool
{
public:
	CAesTool(void);
	~CAesTool(void);

	void setMode(int mode) { if (AES128 <= mode && mode <= AES256) mMode = mode; }
	
	int GetKeySize() const  { return (8 * mMode + 8); }
	int GetSaltSize() const { return (4 * mMode + 4); }

	int init(const unsigned char *key, int keylen);
	int encrypt(unsigned char *data, int len);
	int decrypt(unsigned char *data, int len);
	
	int HmacInit(const unsigned char *key, int keylen);
    int update(const unsigned char *data, int len);
	int doFinal(unsigned char *out, int len);

	static void BytesToBeUInt32s(const unsigned char *src, 
		unsigned long *dest, unsigned destSize);
	static void pbkdf2Hmac(const unsigned char *password, int passwordlen, 
		const unsigned char *salt, int saltlen, unsigned char *out, int outlen);

private:
	int mMode;
	CAesCtr2 mAes;
	CHmac hmac;
};

#endif
